Subject: bug#64756: some frequent test failures

From: Bruno Haible <[email-masked]>
Date: Thu, 30 Nov 2023 11:37:58 +0100

Karl Berry wrote:
>     The various test-suite.log files show different test failures each
> 
> Yes. Painful.  I believe this is due to a timing problem with autom4te,
> exposed by Automake using fractional second sleeps according to what the
> filesystem supports.  It is fixed in the autoconf repository but hasn't
> been released.
> 
> I also noted this and asked for help earlier this year. Bogdan and
> many other contributors looked into it, and Bogdan eventually came up
> with a (tiny) patch for autom4te, which Jacob forwarded to autoconf here:
>   https://lists.gnu.org/archive/html/automake/2023-03/msg00039.html
> and it got installed.

Thanks again for explaining. I encountered what I believe is another
manifestation of the same bug:

In some circumstances, the GNU gettext 'autopoint-3' test fails. More
exactly, an 'automake -a -c' invocation fails with the error messages:
  PREFIX/share/automake-1.16/am/depend2.am: error: am__fastdepCC does not appear in AM_CONDITIONAL
  PREFIX/share/automake-1.16/am/depend2.am:   The usual way to define 'am__fastdepCC' is to add 'AC_PROG_CC'
  PREFIX/share/automake-1.16/am/depend2.am:   to 'configure.ac' and run 'aclocal' and 'autoconf' again
  PREFIX/share/automake-1.16/am/depend2.am: error: AMDEP does not appear in AM_CONDITIONAL
  PREFIX/share/automake-1.16/am/depend2.am:   The usual way to define 'AMDEP' is to add one of the compiler tests
  PREFIX/share/automake-1.16/am/depend2.am:     AC_PROG_CC, AC_PROG_CXX, AC_PROG_OBJC, AC_PROG_OBJCXX,
  PREFIX/share/automake-1.16/am/depend2.am:     AM_PROG_AS, AM_PROG_GCJ, AM_PROG_UPC
  PREFIX/share/automake-1.16/am/depend2.am:   to 'configure.ac' and run 'aclocal' and 'autoconf' again
This is with Automake 1.16.5 and Autoconf 2.71 on an ext4 file system.
The failures occur with probability of ca. 36%.
When I add an 'rm -rf autom4te.cache' command before 'automake -a -c',
the failures disappear.

This is consistent with the analysis from
  https://lists.gnu.org/archive/html/automake/2023-03/msg00039.html
"Bogdan appears to have traced the issue to autom4te caching".

Until a new Autoconf release is public, I'll go with this workaround
to remove the autom4te.cache before invoking automake.

Bruno